"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var index_exports = {};
__export(index_exports, {
  capitalizeWords: () => capitalizeWords,
  findDisallowedCharactersInString: () => findDisallowedCharactersInString,
  isAlphaNumericString: () => isAlphaNumericString,
  isAlphaNumericUnderscoreDashString: () => isAlphaNumericUnderscoreDashString,
  isAlphaNumericUnderscorePeriodString: () => isAlphaNumericUnderscorePeriodString,
  isAlphaNumericUnderscoreSpaceCommaPeriodString: () => isAlphaNumericUnderscoreSpaceCommaPeriodString,
  isAlphaNumericUnderscoreSpaceCommaString: () => isAlphaNumericUnderscoreSpaceCommaString,
  isAlphaNumericUnderscoreSpaceString: () => isAlphaNumericUnderscoreSpaceString,
  isAlphaNumericUnderscoreString: () => isAlphaNumericUnderscoreString,
  isAlphabetString: () => isAlphabetString,
  isAsciiPrintableSpaceAlphanumericSymbolsString: () => isAsciiPrintableSpaceAlphanumericSymbolsString,
  isAsciiPrintableString: () => isAsciiPrintableString,
  isHexString: () => isHexString,
  isNumericString: () => isNumericString,
  isString: () => isString,
  isValidDoubleLengthUUIDString: () => isValidDoubleLengthUUIDString,
  isValidUUIDString: () => isValidUUIDString,
  ltrim: () => ltrim,
  removeCommonFrontPartsFromStringArray: () => removeCommonFrontPartsFromStringArray,
  removeFirstInstanceFromString: () => removeFirstInstanceFromString,
  removeLastLineFromString: () => removeLastLineFromString,
  removeRepeatingCharactersFromString: () => removeRepeatingCharactersFromString,
  rtrim: () => rtrim,
  sortAndDeduplicateAlphanumericStringArray: () => sortAndDeduplicateAlphanumericStringArray,
  sortIntegerStringArray: () => sortIntegerStringArray,
  splitOnFirstNonAsciiPrintableChar: () => splitOnFirstNonAsciiPrintableChar,
  splitStringByLength: () => splitStringByLength,
  stringArrayToString: () => stringArrayToString,
  stringEndsWith: () => stringEndsWith,
  stringEndsWithItemInArray: () => stringEndsWithItemInArray,
  stringRemoveNewlines: () => stringRemoveNewlines,
  stringStartsWith: () => stringStartsWith,
  stringStartsWithItemInArray: () => stringStartsWithItemInArray,
  stringToHexArray: () => stringToHexArray,
  stringToLowercaseUnderscore: () => stringToLowercaseUnderscore,
  stringToNormalizedLowercaseNoSpecialChars: () => stringToNormalizedLowercaseNoSpecialChars,
  stripLeadingWhitespaceFromString: () => stripLeadingWhitespaceFromString,
  tokenizeString: () => tokenizeString
});
module.exports = __toCommonJS(index_exports);

// src/stringtools.ts
var import_node_assert = __toESM(require("assert"));
var isString = function(str) {
  if (typeof str === "string") return true;
  return false;
};
var isAsciiPrintableString = function(str) {
  if (!isString(str)) return false;
  const ascii_check_regexp = new RegExp("^[	\n\r -~]+$", "g");
  if (ascii_check_regexp.test(str) === true) return true;
  return false;
};
var isAsciiPrintableSpaceAlphanumericSymbolsString = function(str) {
  if (!isString(str)) return false;
  const ascii_check_regexp = new RegExp("^[ -~]+$", "g");
  if (ascii_check_regexp.test(str) === true) return true;
  return false;
};
var isAlphaNumericUnderscoreSpaceString = function(str) {
  if (!isString(str)) return false;
  const ascii_check_regexp = new RegExp("^[A-Za-z0-9_ ]+$", "g");
  if (ascii_check_regexp.test(str) === true) return true;
  return false;
};
var isAlphaNumericUnderscorePeriodString = function(str) {
  if (!isString(str)) return false;
  const ascii_check_regexp = new RegExp("^[A-Za-z0-9_.]+$", "g");
  if (ascii_check_regexp.test(str) === true) return true;
  return false;
};
var isAlphaNumericUnderscoreSpaceCommaString = function(str) {
  if (!isString(str)) return false;
  const ascii_check_regexp = new RegExp("^[A-Za-z0-9_ ,]+$", "g");
  if (ascii_check_regexp.test(str) === true) return true;
  return false;
};
var isAlphaNumericUnderscoreSpaceCommaPeriodString = function(str) {
  if (!isString(str)) return false;
  const ascii_check_regexp = new RegExp("^[A-Za-z0-9_ ,.]+$", "g");
  if (ascii_check_regexp.test(str) === true) return true;
  return false;
};
var isAlphaNumericUnderscoreString = function(str) {
  if (!isString(str)) return false;
  const ascii_check_regexp = new RegExp("^[A-Za-z0-9_]+$", "g");
  if (ascii_check_regexp.test(str) === true) return true;
  return false;
};
var isAlphaNumericUnderscoreDashString = function(str) {
  if (!isString(str)) return false;
  const ascii_check_regexp = new RegExp("^[A-Za-z0-9_-]+$", "g");
  if (ascii_check_regexp.test(str) === true) return true;
  return false;
};
var isAlphaNumericString = function(str) {
  if (!isString(str)) return false;
  const ascii_check_regexp = new RegExp("^[A-Za-z0-9]+$", "g");
  if (ascii_check_regexp.test(str) === true) return true;
  return false;
};
var isNumericString = function(str) {
  if (!isString(str)) return false;
  const numeric_check_regexp = new RegExp("^[0-9]+$", "g");
  if (numeric_check_regexp.test(str) === true) return true;
  return false;
};
var isAlphabetString = function(str) {
  if (!isString(str)) return false;
  const ascii_check_regexp = new RegExp("^[A-Za-z]+$", "g");
  if (ascii_check_regexp.test(str) === true) return true;
  return false;
};
var isHexString = function(str) {
  if (!isString(str)) return false;
  const ascii_check_regexp = new RegExp("^[a-f0-9]+$", "g");
  if (ascii_check_regexp.test(str) === true) return true;
  return false;
};
var findDisallowedCharactersInString = function(str, allowed_chars) {
  if (!isString(str))
    import_node_assert.default.fail(
      "Invalid string passed to findDisallowedCharactersInString.  This is certainly using this method in error."
    );
  const disallowed_chars = /* @__PURE__ */ new Map();
  for (let idx = 0; idx < str.length; idx++) {
    const char = str[idx];
    if (!disallowed_chars.has(char) && !allowed_chars.includes(char))
      disallowed_chars.set(char, char);
  }
  if (disallowed_chars.size > 0) return Array.from(disallowed_chars.values());
  return null;
};
var splitOnFirstNonAsciiPrintableChar = function(str) {
  if (typeof str !== "string") return null;
  if (str.length <= 0) return null;
  const isPrintableAscii = (char) => char.charCodeAt(0) >= 32 && char.charCodeAt(0) <= 126;
  for (let i = 0; i < str.length; i++) {
    if (!isPrintableAscii(str[i])) {
      return [str.slice(0, i), str.slice(i)];
    }
  }
  return [str, ""];
};
var stripLeadingWhitespaceFromString = function(str) {
  if (isString(str) !== true) {
    debugger;
    import_node_assert.default.fail(
      "Invalid string passed to stripLeadingWhitespaceFromString.  This is certainly using this method in error."
    );
  }
  if (str.length <= 0) return str;
  while (true) {
    if (str.length <= 0) return str;
    switch (str[0]) {
      // remove spaces and tabs
      case " ":
      case "	":
        str = str.substring(1);
        break;
      // return the string
      default:
        return str;
    }
  }
};
var removeFirstInstanceFromString = function(str, search) {
  if (isString(str) !== true) {
    debugger;
    import_node_assert.default.fail(
      "Invalid string passed to removeFirstInstanceFromString.  This is certainly using this method in error."
    );
  }
  if (isString(search) !== true) {
    debugger;
    import_node_assert.default.fail(
      "Invalid search string passed to removeFirstInstanceFromString.  This is certainly using this method in error."
    );
  }
  if (str.length <= search.length) return str;
  const idx = str.indexOf(search);
  if (idx === -1) return str;
  const mod_str = str.substring(idx + search.length);
  return mod_str;
};
var removeRepeatingCharactersFromString = function(val) {
  if (isString(val) !== true) {
    debugger;
    import_node_assert.default.fail(
      "Invalid string passed to removeRepeatingCharactersFromString.  This is certainly using this method in error."
    );
  }
  let new_string = "";
  let last_char = null;
  let curr_char = null;
  for (let idx = 0; idx < val.length; idx++) {
    curr_char = val[idx];
    if (last_char === null) new_string += curr_char;
    else {
      if (last_char !== curr_char) new_string += curr_char;
    }
    last_char = val[idx];
  }
  return new_string;
};
var rtrim = function(str) {
  if (isString(str) !== true) {
    debugger;
    import_node_assert.default.fail(
      "Invalid string passed to chop.  This is certainly using this method in error."
    );
  }
  return str.slice(0, -1);
};
var ltrim = function(str) {
  return str.slice(1);
};
var isValidUUIDString = function(uuid_val) {
  if (!isString(uuid_val)) return false;
  if (uuid_val.length !== 36) return false;
  if (/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i.test(
    uuid_val
  ) !== true) {
    return false;
  }
  return true;
};
var isValidDoubleLengthUUIDString = function(double_length_uuid_val) {
  if (!isString(double_length_uuid_val)) return false;
  if (double_length_uuid_val.length !== 72) return false;
  if (/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i.test(
    double_length_uuid_val
  ) !== true) {
    return false;
  }
  return true;
};
var sortIntegerStringArray = function(int_string_array) {
  if (Array.isArray(int_string_array) === false) return null;
  const numeric_arr = [];
  for (let idx = 0; idx < int_string_array.length; idx++) {
    try {
      numeric_arr.push(parseInt(int_string_array[idx]));
    } catch (err) {
    }
  }
  numeric_arr.sort(function(a, b) {
    return a - b;
  });
  const sorted_results = [];
  for (let idx = 0; idx < numeric_arr.length; idx++) {
    sorted_results.push(numeric_arr[idx].toString());
  }
  return sorted_results;
};
var sortAndDeduplicateAlphanumericStringArray = function(str_array) {
  if (Array.isArray(str_array) !== true) return null;
  if (str_array.length <= 0) return null;
  const cleanedArray = str_array.map(function(str) {
    return str.replace(/[^a-zA-Z0-9]/g, "").toLowerCase();
  });
  const sortedArray = cleanedArray.sort();
  const uniqueArray = sortedArray.filter(
    (value, index, self) => self.indexOf(value) === index
  );
  if (uniqueArray.length <= 0) return null;
  return uniqueArray;
};
var tokenizeString = function(params) {
  let input_string = params.input_string;
  const options = params.options;
  if (typeof input_string !== "string") return null;
  if (input_string.length <= 0) return null;
  input_string = input_string.replace(/[^a-zA-Z0-9\s]/g, " ");
  if (input_string.length <= 0) return null;
  if (isAsciiPrintableString(input_string) !== true) return null;
  input_string = input_string.replace(/\s+/g, " ");
  if (input_string.length <= 0) return null;
  let string_array = input_string.split(" ");
  if (string_array.length <= 0) return null;
  string_array = string_array.map((str) => str.replace(/\s/g, "")).filter((str) => typeof str === "string" && str !== "");
  if (string_array.length <= 0) return null;
  if ((options == null ? void 0 : options.to_lowercase) === true)
    string_array = string_array.map((str) => str.toLowerCase());
  if (string_array.length <= 0) return null;
  if ((options == null ? void 0 : options.deduplicate) === true)
    string_array = string_array.filter(
      (value, index, self) => self.indexOf(value) === index
    );
  if (string_array.length <= 0) return null;
  if ((options == null ? void 0 : options.sort) === true) string_array.sort();
  return string_array;
};
var capitalizeWords = function(str, separator = " ") {
  if (!isString(str)) {
    import_node_assert.default.fail(
      "Invalid string passed to capitalizeWords.  This is certainly using this method in error."
    );
  }
  if (str.length <= 0) return null;
  const separated_string = str.split(separator);
  if (separated_string.length <= 0) return str.charAt(0).toUpperCase();
  const capitalized_string = str.split(separator).map((s) => s.charAt(0).toUpperCase() + s.substring(1)).join(separator);
  return capitalized_string;
};
var stringToLowercaseUnderscore = function(str_to_convert) {
  if (!isString(str_to_convert)) {
    import_node_assert.default.fail(
      "Invalid string passed to stringToLowercaseUnderscore.  This is certainly using this method in error."
    );
  }
  if (str_to_convert.length <= 0) return "";
  str_to_convert = str_to_convert.toLowerCase();
  str_to_convert = str_to_convert.replaceAll(/\s/g, "_");
  return str_to_convert.replace(/[^a-z0-9_]+/gi, "");
};
var stringToNormalizedLowercaseNoSpecialChars = function(params) {
  let input_string = params == null ? void 0 : params.input_string;
  const options = params == null ? void 0 : params.options;
  if (!isString(input_string)) {
    import_node_assert.default.fail(
      "Invalid string passed to stringToNormalizedLowercaseNoSpecialChars.  This is certainly using this method in error."
    );
  }
  if (input_string.length <= 0) return null;
  input_string = input_string.replace(/[^a-zA-Z0-9\s]/g, " ");
  if (input_string.length <= 0) return null;
  if (isAsciiPrintableString(input_string) !== true) return null;
  input_string = input_string.replace(/\s+/g, " ");
  if (input_string.length <= 0) return null;
  let string_array = input_string.split(" ");
  if (string_array.length <= 0) return null;
  string_array = string_array.map((str) => str.replace(/\s/g, "")).filter((str) => typeof str === "string" && str !== "");
  if (string_array.length <= 0) return null;
  if ((options == null ? void 0 : options.to_lowercase) === true)
    string_array = string_array.map((str) => str.toLowerCase());
  if (string_array.length <= 0) return null;
  let join_str = " ";
  if (typeof (options == null ? void 0 : options.join_str) === "string") join_str = options.join_str;
  const final_string = string_array.join(join_str);
  return final_string.toLowerCase();
};
var stringToHexArray = function(input_string) {
  if (!isString(input_string)) {
    import_node_assert.default.fail(
      "Invalid string passed to stringToHexArray.  This is certainly using this method in error."
    );
  }
  const hex_array = [];
  for (let i = 0; i < input_string.length; i++) {
    hex_array.push(input_string.charCodeAt(i).toString(16));
  }
  return hex_array;
};
var stringEndsWith = function(str, ends_with) {
  if (!isString(str)) {
    import_node_assert.default.fail(
      "Invalid string passed to stringEndsWith.  This is certainly using this method in error."
    );
  }
  if (!isString(ends_with)) {
    import_node_assert.default.fail(
      "Invalid ends_with string passed to stringEndsWith.  This is certainly using this method in error."
    );
  }
  if (str.length < ends_with.length) return false;
  if (str.substring(str.length - ends_with.length) == ends_with) return true;
  return false;
};
var stringEndsWithItemInArray = function(str, array_of_end_items) {
  for (let idx = 0; idx < array_of_end_items.length; idx++) {
    if (stringEndsWith(str, array_of_end_items[idx]) === true) return true;
  }
  return false;
};
var stringStartsWith = function(str, starts_with) {
  if (str.indexOf(starts_with) === 0) return true;
  return false;
};
var stringStartsWithItemInArray = function(str, array_of_start_items) {
  if (!isString(str)) {
    import_node_assert.default.fail(
      "Invalid string passed to stringStartsWithItemInArray.  This is certainly using this method in error."
    );
  }
  for (let idx = 0; idx < array_of_start_items.length; idx++) {
    if (stringStartsWith(str, array_of_start_items[idx]) === true) return true;
  }
  return false;
};
var stringRemoveNewlines = function(str) {
  if (!isString(str)) {
    import_node_assert.default.fail(
      "Invalid string passed to stringRemoveNewlines.  This is certainly using this method in error."
    );
  }
  str = str.replace(/\r?\n|\r/g, "");
  return str;
};
var removeLastLineFromString = function(str, char = "\n") {
  if (!isString(str)) {
    import_node_assert.default.fail(
      "Invalid string passed to removeLastLineFromString.  This is certainly using this method in error."
    );
  }
  try {
    str = str.substring(0, str.lastIndexOf(char));
  } catch (err) {
  }
  return str;
};
var removeCommonFrontPartsFromStringArray = function(strings) {
  if (strings.length === 0) return [];
  const shortest_string = strings.reduce((acc, str) => {
    return str.length < acc.length ? str : acc;
  });
  for (let i = 0; i < shortest_string.length; i++) {
    const common_prefix = shortest_string.slice(0, i + 1);
    const is_common = strings.every((str) => str.startsWith(common_prefix));
    if (!is_common)
      return strings.map((str) => str.slice(common_prefix.length - 1));
  }
  return strings.map((str) => str.slice(shortest_string.length));
};
var stringArrayToString = function(string_array, seperator) {
  if (Array.isArray(string_array) !== true) return null;
  if (string_array.length <= 0) return null;
  if (string_array.length === 1) return string_array[0];
  return string_array.join(seperator);
};
var splitStringByLength = function(string, length, replacement = "\n") {
  if (Number.isInteger(length) !== true)
    import_node_assert.default.fail("splitStringByLength: Invalid length parameter passed.");
  if (isString(string) !== true)
    import_node_assert.default.fail("splitStringByLength: Invalid string parameter passed.");
  if (isString(replacement) !== true)
    import_node_assert.default.fail("splitStringByLength: Invalid replacement parameter passed.");
  let new_string = "";
  let length_counter = 0;
  for (let idx = 0; idx < string.length; idx++) {
    new_string += string[idx] + "";
    if (length_counter === length - 1) {
      if (string.length - idx > length) new_string += replacement;
      length_counter = 0;
    } else {
      length_counter++;
    }
  }
  return new_string;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  capitalizeWords,
  findDisallowedCharactersInString,
  isAlphaNumericString,
  isAlphaNumericUnderscoreDashString,
  isAlphaNumericUnderscorePeriodString,
  isAlphaNumericUnderscoreSpaceCommaPeriodString,
  isAlphaNumericUnderscoreSpaceCommaString,
  isAlphaNumericUnderscoreSpaceString,
  isAlphaNumericUnderscoreString,
  isAlphabetString,
  isAsciiPrintableSpaceAlphanumericSymbolsString,
  isAsciiPrintableString,
  isHexString,
  isNumericString,
  isString,
  isValidDoubleLengthUUIDString,
  isValidUUIDString,
  ltrim,
  removeCommonFrontPartsFromStringArray,
  removeFirstInstanceFromString,
  removeLastLineFromString,
  removeRepeatingCharactersFromString,
  rtrim,
  sortAndDeduplicateAlphanumericStringArray,
  sortIntegerStringArray,
  splitOnFirstNonAsciiPrintableChar,
  splitStringByLength,
  stringArrayToString,
  stringEndsWith,
  stringEndsWithItemInArray,
  stringRemoveNewlines,
  stringStartsWith,
  stringStartsWithItemInArray,
  stringToHexArray,
  stringToLowercaseUnderscore,
  stringToNormalizedLowercaseNoSpecialChars,
  stripLeadingWhitespaceFromString,
  tokenizeString
});
